#include "testlib.h"
#include <set>
#include <vector>

using namespace std;

const int N = 100179;

int n, m;
set < int > e[N];

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    m = inf.readInt();
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        a = inf.readInt();
        b = inf.readInt();
        e[a].insert(b);
        e[b].insert(a);
    }

	int q = inf.readInt();
	for (int i = 1; i <= q; ++i)
	{
		int l = inf.readInt();
		int r = inf.readInt();
		
		int jCnt = ans.readInt();
		for (int i = 0; i < jCnt; ++i)
			ans.readInt();
		
		int pCnt = ouf.readInt(-1, min(r - l + 1, 100), "cnt_i");
		quitif(0 <= pCnt && pCnt <= 2, _wa, "%d is an incorrect loop length", pCnt);
		quitif(pCnt == -1 && jCnt != -1, _wa, "participant has no answer but jury has");

		if (pCnt == -1)
			continue;
		
		vector < int > pAns;
		for (int j = 0; j < pCnt; ++j)
			pAns.push_back(ouf.readInt(l, r));
		quitif((int)set<int>(pAns.begin(), pAns.end()).size() != pCnt, _wa,
			"loop must not contain the same vertex twice");
		int z = 0;
		for (int j = 0; j < pCnt; ++j)
			z += e[pAns[j]].count(pAns[(j+1) % pCnt]);
		quitif(z != 0 && z != pCnt, _wa, "participant's loop is incorrect");
		quitif(jCnt == -1, _fail, "jury has no answer but participant has");
	}

    quitf(_ok, "ok");
}	

