/**
 *    author:  [itmo] enot.1.10
 *    created: 18.02.2017 06:06:25       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 1e5 + 10;

unordered_set<ll> S;

ll code(int x, int y)
{
    return x * pw(30) + y;
}

int getColor(int x, int y)
{
    if (x > y) swap(x, y);
    int res;
    if (S.find(code(x, y)) != S.end()) res = 0;
    else res = 1;
    return res;
}

int main()
{
    assert(freopen("loopquery.in", "r", stdin));
    assert(freopen("loopquery.out", "w", stdout));
    int n, m;
    scanf("%d%d", &n, &m);
    forn(i, m)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        if (x > y) swap(x, y);
        S.insert(code(x, y));
    }
    int q;
    scanf("%d", &q);
    forn(_, q)
    {
        int l, r;
        scanf("%d%d", &l, &r);
        r = min(r, l + 5);
        vi v;
        for (int i = l; i <= r; ++i) v.pb(i);
        int ok = 0;
        do
        {
            if (sz(v) < 2) break;
            int color = getColor(v[0], v[1]);
            for (int i = 2; i < sz(v); ++i)
            {
                if (color != getColor(v[i - 1], v[i])) break;
                if (getColor(v[i], v[0]) == color)
                {
                    ok = 1;
                    printf("%d ", i + 1);
                    for (int j = 0; j <= i; ++j) printf("%d%c", v[j], " \n"[j == i]);
                    break;
                }
            }
            if (ok) break;
        }
        while (next_permutation(all(v)));
        if (!ok) printf("-1\n");
    }
                    
                
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
