import java.util.*;
import java.io.*;

public class stones_dp {
    FastScanner in;
    PrintWriter out;

    public void solve() throws IOException {
        int n = in.nextInt();
        List<Integer> balls = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            balls.add(in.nextInt());
        }
        Collections.sort(balls);
        int answer = Integer.MAX_VALUE;
        for (int i = 0; i < balls.size(); i++) {
            int l = balls.get(i);
            int r = balls.get(i) + balls.size() - 1;
            int index = Collections.binarySearch(balls, r);
            if (index < 0) {
                index = -index - 2;
            }
            int ballsCount = index - i + 1;
            answer = Math.min(answer, balls.size() - ballsCount);
        }
        out.println(answer);      
    }

    public void run() {
        try {
            in = new FastScanner(new File("stones.in"));
            out = new PrintWriter(new File("stones.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new stones_dp().run();
    }
}
